https://leetcode.cn/problems/monotone-increasing-digits/
题目要求
当且仅当每个相邻位数上的数字 x 和 y 满足 x <= y 时,我们称这个整数是单调递增的。
给定一个整数 n ,返回 小于或等于 n 的最大数字,且数字呈 单调递增 。
暴力
class Solution {
public int monotoneIncreasingDigits(int n) {
for (int i = n; i > 0; i--) {
if (isIncrease(i))
return i;
}
return -1;
}
public boolean isIncrease(int n) {
int cur, pre = Integer.MAX_VALUE;
while (n > 0) {
cur = n % 10;
if (cur <= pre) {
n /= 10;
pre = cur;
} else
return false;
}
return true;
}
}
- 暴力解法会超时
贪心:找到修改位置
class Solution {
public int monotoneIncreasingDigits(int n) {
StringBuilder str = new StringBuilder(String.valueOf(n));
int len = str.length();
int start = str.length();
for (int i = len - 1; i > 0; i--) {
if (str.charAt(i - 1) > str.charAt(i)) {
str.setCharAt(i - 1, (char) (str.charAt(i - 1) - 1));
start = i;
}
}
for (int i = start; i < len; i++) {
str.setCharAt(i, '9');
}
return Integer.parseInt(str.toString());
}
}
- 例如98,一旦出现
str.charAt(i - 1) > str.charAt(i)
的情况(非单调递增),首先想让str.charAt(i - 1)--
,然后str.charAt(i)
给为9,这样这个整数就是89,即小于98的最大的单调递增整数。 - 所以只要找到第一个修改的位置,这个位置之后的数字都修改为9即可;